## blog.schmitouille.net
## Lightweight ActiveDirectory Toolbox - r4
## Consulter le fichier d'info fourni dans l'archive pour plus d'informations

Add-Type -AssemblyName System.Windows.Forms
[System.Windows.Forms.Application]::EnableVisualStyles()
$curver = "r4"


#region UI-objects

	#region Form
$mainForm = New-Object System.Windows.Forms.Form
$mainForm.ClientSize = '620,580'
$mainForm.Text = "Lightweight ActiveDirectory Toolbox - $curver"
$mainForm.FormBorderStyle = 'Fixed3D'
$mainForm.MaximizeBox = $false
    #endregion
	
	#region TabControl
$mainTabCtl = New-Object System.Windows.Forms.TabControl
$mainTabCtl.Location = New-Object System.Drawing.Point(15,55)
$mainTabCtl.Size = '590,515'
$mainTabCtl.ShowToolTips = $true

$consultTabPage = New-Object System.Windows.Forms.TabPage
#$createTabPage = New-Object System.Windows.Forms.TabPage
$groupTabPage = New-Object System.Windows.Forms.TabPage
$adTabPage = New-Object System.Windows.Forms.TabPage
$logTabPage = New-Object System.Windows.Forms.TabPage

$consultTabPage.Text = "Users"
$consultTabPage.ToolTipText = "Retrieve information regarding a user account and operate basic actions."
#$createTabPage.Text = "Create User"
#$createTabPage.ToolTipText = "Create a user account."
$groupTabPage.Text = "Groups"
$groupTabPage.ToolTipText = "Retrieve informations regarding groups."
$adTabPage.Text = "Active Directory Info"
$adTabPage.ToolTipText = "Get access to some information about the domain controllers and operate basic actions."
$logTabPage.Text = "Log"
$logTabPage.ToolTipText = "Check the log of changes and actions you made since application start."

$mainTabCtl.TabPages.AddRange(@($consultTabPage,$groupTabPage,$adTabPage,$logTabPage))

$mainForm.controls.Add($mainTabCtl)
	#endregion
	
	#region Labels    
$statusLabelFix = New-Object System.Windows.Forms.Label
$statusLabelFix.Location = New-Object System.Drawing.Point(10,30)
$statusLabelFix.AutoSize = $true
$statusLabelFix.Text = "Status:"
$statusLabelVar = New-Object System.Windows.Forms.Label
$statusLabelVar.Location = New-Object System.Drawing.Point(55,30)
$statusLabelVar.AutoSize = $true
$statusLabelVar.Text = "Ready."

$accNameLabelFix = New-Object System.Windows.Forms.Label
$accNameLabelFix.Location = New-Object System.Drawing.Point(25,85)
$accNameLabelFix.Text = "User Name:"
$accNameLabelFix.AutoSize = $true
$accNameLabelVar = New-Object System.Windows.Forms.Label
$accNameLabelVar.Location = New-Object System.Drawing.Point(90,85)
$accNameLabelVar.AutoSize = $true

$accDisplayNameFix = New-Object System.Windows.Forms.Label
$accDisplayNameFix.Location = New-Object System.Drawing.Point(25,105)
$accDisplayNameFix.Text = "Display Name:"
$accDisplayNameFix.AutoSize = $true
$accDisplayNameVar = New-Object System.Windows.Forms.Label
$accDisplayNameVar.Location = New-Object System.Drawing.Point(105,105)
$accDisplayNameVar.AutoSize = $true

$lastlogonDateFix = New-Object System.Windows.Forms.Label
$lastlogonDateFix.Location = New-Object System.Drawing.Point(25,125)
$lastlogonDateFix.Text = "Last Logon Date:"
$lastlogonDateFix.AutoSize = $true
$lastlogonDateVar = New-Object System.Windows.Forms.Label
$lastlogonDateVar.Location = New-Object System.Drawing.Point(115,125)
$lastlogonDateVar.AutoSize = $true

$distinguishedNameFix = New-Object System.Windows.Forms.Label
$distinguishedNameFix.Location = New-Object System.Drawing.Point(25,145)
$distinguishedNameFix.Text = "Distinguished Name:"
$distinguishedNameFix.AutoSize = $true
$distinguishedNameVar = New-Object System.Windows.Forms.Label
$distinguishedNameVar.Location = New-Object System.Drawing.Point(135,145)
$distinguishedNameVar.AutoSize=$true
$distinguishedNameVar.MaximumSize = New-Object System.Drawing.Size(215,0)

$lastwrongpwFix = New-Object System.Windows.Forms.Label
$lastwrongpwFix.Location = New-Object System.Drawing.Point(25,380)
$lastwrongpwFix.Text = "Last wrong password timestamp:"
$lastwrongpwFix.AutoSize = $true
$lastwrongpwVar = New-Object System.Windows.Forms.Label
$lastwrongpwVar.Location = New-Object System.Drawing.Point(195,380)
$lastwrongpwVar.AutoSize = $true

$lastSetpwFix = New-Object System.Windows.Forms.Label
$lastSetpwFix.Location = New-Object System.Drawing.Point(25,400)
$lastSetpwFix.Text = "Password Set on:"
$lastSetpwFix.AutoSize = $true
$lastSetpwVar = New-Object System.Windows.Forms.Label
$lastSetpwVar.Location = New-Object System.Drawing.Point(118,400)
$lastSetpwVar.AutoSize = $true

$pwNeverExpLabel = New-Object System.Windows.Forms.Label
$pwNeverExpLabel.Location = New-Object System.Drawing.Point(25,420)
$pwNeverExpLabel.Text = "Never expires :"
$pwNeverExpLabel.AutoSize = $true
$pwExpiredLabel = New-Object System.Windows.Forms.Label
$pwExpiredLabel.Location = New-Object System.Drawing.Point(165,420)
$pwExpiredLabel.Text = "Is Expired :"
$pwExpiredLabel.AutoSize = $true

$accExpDateFix = New-Object System.Windows.Forms.Label
$accExpDateFix.Location = New-Object System.Drawing.Point(25,440)
$accExpDateFix.Text = "Account Expires On:"
$accExpDateFix.AutoSize = $true
$accExpDateVar = New-Object System.Windows.Forms.Label
$accExpDateVar.Location = New-Object System.Drawing.Point(135,440)
$accExpDateVar.Text = "Not Set"
$accExpDateVar.AutoSize = $true

$whencreatedFix = New-Object System.Windows.Forms.Label
$whencreatedFix.Location = New-Object System.Drawing.Point(25,265)
$whencreatedFix.Text = "Creation date:"
$whencreatedFix.AutoSize = $true
$whencreatedVar = New-Object System.Windows.Forms.Label
$whencreatedVar.Location = New-Object System.Drawing.Point(100,265)
$whencreatedVar.AutoSize = $true

$groupMemberFix = New-Object System.Windows.Forms.Label
$groupMemberFix.Location = New-Object System.Drawing.Point(25,285)
$groupMemberFix.Text = "User belongs to the following groups:"
$groupMemberFix.AutoSize = $true

$lockedBoolLabel = New-Object System.Windows.Forms.Label
$lockedBoolLabel.Location = New-Object System.Drawing.Point(25,355)
$lockedBoolLabel.AutoSize = $true
$lockedBoolLabel.Text = "Locked :"

$enabledBoolLabel = New-Object System.Windows.Forms.Label
$enabledBoolLabel.Location = New-Object System.Drawing.Point(165,355)
$enabledBoolLabel.Text = "Enabled :"
$enabledBoolLabel.AutoSize = $true

$DCListLabel = New-Object System.Windows.Forms.Label
$DCListLabel.Location = New-Object System.Drawing.Point(25,335)
$DCListLabel.Text = "Select a domain controller to perform actions."
$DCListLabel.AutoSize = $true

$DCIPV4LabelFix = New-Object System.Windows.Forms.Label
$DCIPV4LabelFix.Location = New-Object System.Drawing.Point(25,385)
$DCIPV4LabelFix.Text = "IPV4:"
$DCIPV4LabelFix.AutoSize = $true
$DCIPV4LabelVar = New-Object System.Windows.Forms.Label
$DCIPV4LabelVar.Location = New-Object System.Drawing.Point(55,385)
$DCIPV4LabelVar.AutoSize = $true

$DCOSverLabelFix = New-Object System.Windows.Forms.Label
$DCOSverLabelFix.Location = New-Object System.Drawing.Point(25,410)
$DCOSverLabelFix.Text = "OS:"
$DCOSverLabelFix.AutoSize = $true
$DCOSverLabelVar = New-Object System.Windows.Forms.Label
$DCOSverLabelVar.Location = New-Object System.Drawing.Point(50,410)
$DCOSverLabelVar.AutoSize = $true

$DCSiteLabelFix = New-Object System.Windows.Forms.Label
$DCSiteLabelFix.Location = New-Object System.Drawing.Point(25,435)
$DCSiteLabelFix.Text = "Site:"
$DCSiteLabelFix.AutoSize = $true
$DCSiteLabelVar = New-Object System.Windows.Forms.Label
$DCSiteLabelVar.Location = New-Object System.Drawing.Point(50,435)
$DCSiteLabelVar.AutoSize = $true

$GrpFilterLabel = New-Object System.Windows.Forms.Label
$GrpFilterLabel.Location = New-Object System.Drawing.Point(155,20)
$GrpFilterLabel.Text = "Filter:"
$GrpFilterLabel.AutoSize = $true

$GrpListLabel = New-Object System.Windows.Forms.Label
$GrpListLabel.Location = New-Object System.Drawing.Point(25,295)
$GrpListLabel.Text = "Select a group to see its users and perform actions."
$GrpListLabel.AutoSize = $true

$mainForm.controls.AddRange(@($statusLabelFix,$statusLabelVar))
$consultTabPage.controls.AddRange(@($accNameLabelFix,$accNameLabelVar,$accDisplayNameFix,$accDisplayNameVar,$lastlogonDateFix,$lastlogonDateVar,$groupMemberFix,$distinguishedNameFix,$distinguishedNameVar,$lastwrongpwFix,$lastwrongpwVar,$lockedBoolLabel,$enabledBoolLabel,$whencreatedFix,$whencreatedVar,$lastSetpwFix,$lastSetpwVar,$pwNeverExpLabel,$pwExpiredLabel,$accExpDateFix,$accExpDateVar))
$adTabPage.controls.AddRange(@($DCListLabel,$DCIPV4LabelFix,$DCIPV4LabelVar,$DCOSverLabelFix,$DCOSverLabelVar,$DCSiteLabelFix,$DCSiteLabelVar))
$groupTabPage.controls.AddRange(@($GrpFilterLabel,$GrpListLabel))
    #endregion

    #region ComboBox
$GroupComboBox = New-Object System.Windows.Forms.ComboBox
$GroupComboBox.Location = New-Object System.Drawing.Point(25,315)
$GroupComboBox.DropDownStyle = "DropDownList"
$GroupComboBox.Width = 340
$GroupComboBox.TabIndex = 3

$DCListComboBox = New-Object System.Windows.Forms.ComboBox
$DCListComboBox.Location = New-Object System.Drawing.Point(25,355)
$DCListComboBox.DropDownStyle = "DropDownList"
$DCListComboBox.Width = 300
$DCListComboBox.TabIndex = 4

$GrpListComboBox = New-Object System.Windows.Forms.ComboBox
$GrpListComboBox.Location = New-Object System.Drawing.Point(25,315)
$GrpListComboBox.DropDownStyle = "DropDownList"
$GrpListComboBox.Width = 420
$GrpListComboBox.TabIndex = 5

$consultTabPage.controls.Add($GroupComboBox)
$adTabPage.controls.Add($DCListComboBox)
$groupTabPage.controls.Add($GrpListComboBox)
    #endregion

    #region TextBox
$accNameTextBox = New-Object System.Windows.Forms.TextBox
$accNameTextBox.Location = New-Object System.Drawing.Point(20,25)
$accNameTextBox.Width = 100
$accNameTextBox.Height = 30
$accNameTextBox.TabIndex = 0

$changePwTextBox1 = New-Object System.Windows.Forms.TextBox
$changePwTextBox1.Location = New-Object System.Drawing.Point(395,415)
$changePwTextBox1.Width = 165
$changePwTextBox1.TabIndex = 16
$changePwTextBox1.PasswordChar = '*'
$changePwTextBox2 = New-Object System.Windows.Forms.TextBox
$changePwTextBox2.Location = New-Object System.Drawing.Point(395,440)
$changePwTextBox2.Width = 165
$changePwTextBox2.TabIndex = 17
$changePwTextBox2.PasswordChar = '*'

$grpFilterTextBox = New-Object System.Windows.Forms.TextBox
$grpFilterTextBox.Location = New-Object System.Drawing.Point(190,15)
$grpFilterTextBox.Width = 180
$grpFilterTextBox.TabIndex = 2

$consultTabPage.controls.AddRange(@($accNameTextBox,$changePwTextBox1,$changePwTextBox2))
$groupTabPage.controls.Add($grpFilterTextBox)
    #endregion

    #region Buttons
$RetrieveUserInfoButton = New-Object System.Windows.Forms.Button
$RetrieveUserInfoButton.Location = New-Object System.Drawing.Point(140,25)
$RetrieveUserInfoButton.text = "Retrieve Info"
$RetrieveUserInfoButton.width = 80
$RetrieveUserInfoButton.height = 20
$RetrieveUserInfoButton.TabIndex = 1

$RetrieveDCListButton = New-Object System.Windows.Forms.Button
$RetrieveDCListButton.Location = New-Object System.Drawing.Point(20,15)
$RetrieveDCListButton.Text = "Retrieve Domain Controllers"
$RetrieveDCListButton.width = 200
$RetrieveDCListButton.TabIndex = 1

$ExportDCListButton = New-Object System.Windows.Forms.Button
$ExportDCListButton.Location = New-Object System.Drawing.Point(250,15)
$ExportDCListButton.Text = "Export DC List"
$ExportDCListButton.width = 120
$ExportDCListButton.TabIndex = 2

$RefreshButton = New-Object System.Windows.Forms.Button
$RefreshButton.Location = New-Object System.Drawing.Point(240,25)
$RefreshButton.text = "Refresh"
$RefreshButton.width = 80
$RefreshButton.height = 20
$RefreshButton.TabIndex = 2

$ResetButton = New-Object System.Windows.Forms.Button
$ResetButton.Location = New-Object System.Drawing.Point(340,25)
$ResetButton.Text = "Reset"
$ResetButton.width = 80
$ResetButton.height = 20
$ResetButton.TabIndex = 3

$ResetDCListButton = New-Object System.Windows.Forms.Button
$ResetDCListButton.Location = New-Object System.Drawing.Point(400,15)
$ResetDCListButton.Text = "Clear DC List"
$ResetDCListButton.Width = 160
$ResetDCListButton.TabIndex = 3

$ExportToFileButton = New-Object System.Windows.Forms.Button
$ExportToFileButton.Location = New-Object System.Drawing.Point(395,85)
$ExportToFileButton.Text = "Export to File"
$ExportToFileButton.Width = 165
$ExportToFileButton.TabIndex = 4

$UnlockAccButton = New-Object System.Windows.Forms.Button
$UnlockAccButton.Location = New-Object System.Drawing.Point(395,115)
$UnlockAccButton.Text = "Unlock Account"
$UnlockAccButton.Width = 165
$UnlockAccButton.TabIndex = 5

$DisableAccButton = New-Object System.Windows.Forms.Button
$DisableAccButton.Location = New-Object System.Drawing.Point(395,145)
$DisableAccButton.Text = "Disable Account"
$DisableAccButton.Width = 165
$DisableAccButton.TabIndex = 6

$EnableAccButton = New-Object System.Windows.Forms.Button
$EnableAccButton.Location = New-Object System.Drawing.Point(395,175)
$EnableAccButton.Text = "Enable Account"
$EnableAccButton.Width = 165
$EnableAccButton.TabIndex = 7

$SetExpDateButton = New-Object System.Windows.Forms.Button
$SetExpDateButton.Location = New-Object System.Drawing.Point(395,215)
$SetExpDateButton.Text = "Set account expiration date"
$SetExpDateButton.Width = 165
$SetExpDateButton.TabIndex = 8

$disableExpDateButton = New-Object System.Windows.Forms.Button
$disableExpDateButton.Location = New-Object System.Drawing.Point(395,280)
$disableExpDateButton.Text = "Remove account exp. date"
$disableExpDateButton.Width = 165
$disableExpDateButton.TabIndex = 12

$neverExpPwButton = New-Object System.Windows.Forms.Button
$neverExpPwButton.Location = New-Object System.Drawing.Point(395,320)
$neverExpPwButton.Text = "Password shall not expire"
$neverExpPwButton.Width = 165
$neverExpPwButton.TabIndex = 13

$doesExpPwButton = New-Object System.Windows.Forms.Button
$doesExpPwButton.Location = New-Object System.Drawing.Point(395,350)
$doesExpPwButton.Text = "Password shall expire"
$doesExpPwButton.Width = 165
$doesExpPwButton.TabIndex = 14

$changeUserPwButton = New-Object System.Windows.Forms.Button
$changeUserPwButton.Location = New-Object System.Drawing.Point(395,385)
$changeUserPwButton.Text = "Change user password"
$changeUserPwButton.Width = 165
$changeUserPwButton.TabIndex = 15

$clearLogButton = New-Object System.Windows.Forms.Button
$clearLogButton.Location = New-Object System.Drawing.Point(20,450)
$clearLogButton.Text = "Clear log"
$clearLogButton.Width = 125
$clearLogButton.TabIndex = 1

$exportLogButton = New-Object System.Windows.Forms.Button
$exportLogButton.Location = New-Object System.Drawing.Point(435,450)
$exportLogButton.Text = "Export log to CSV"
$exportLogButton.Width = 125
$exportLogButton.TabIndex = 2

$mstscButton = New-Object System.Windows.Forms.Button
$mstscButton.Location = New-Object System.Drawing.Point(370,335)
$mstscButton.Text = "Open RDP connection"
$mstscButton.Width = 170
$mstscButton.TabIndex = 5

$dcdiagButton = New-Object System.Windows.Forms.Button
$dcdiagButton.Location = New-Object System.Drawing.Point(370,365)
$dcdiagButton.Text = "Run dcdiag"
$dcdiagButton.Width = 170
$dcdiagButton.TabIndex = 6

$dcdiagRepButton = New-Object System.Windows.Forms.Button
$dcdiagRepButton.Location = New-Object System.Drawing.Point(370,395)
$dcdiagRepButton.Text = "Run dcdiag /test:replications"
$dcdiagRepButton.Width = 170
$dcdiagRepButton.TabIndex = 7

$dcdiagDnsButton = New-Object System.Windows.Forms.Button
$dcdiagDnsButton.Location = New-Object System.Drawing.Point(370,425)
$dcdiagDnsButton.Text = "Run dcdiag /test:dns"
$dcdiagDnsButton.Width = 170
$dcdiagDnsButton.TabIndex = 8

$GetGrpButton = New-Object System.Windows.Forms.Button
$GetGrpButton.Location = New-Object System.Drawing.Point(20,15)
$GetGrpButton.Text = "Retrieve AD Groups"
$GetGrpButton.Width = 120
$GetGrpButton.TabIndex = 1

$ClearGrpDGVButton = New-Object System.Windows.Forms.Button
$ClearGrpDGVButton.Location = New-Object System.Drawing.Point(390,15)
$ClearGrpDGVButton.Text = "Clear List"
$ClearGrpDGVButton.Width = 75
$ClearGrpDGVButton.TabIndex = 3

$ExportGrpDGVButton = New-Object System.Windows.Forms.Button
$ExportGrpDGVButton.Location = New-Object System.Drawing.Point(485,15)
$ExportGrpDGVButton.Text = "Export List"
$ExportGrpDGVButton.Width = 75
$ExportGrpDGVButton.TabIndex = 4

$ExportGrpInfoButton = New-Object System.Windows.Forms.Button
$ExportGrpInfoButton.Location = New-Object System.Drawing.Point(470,315)
$ExportGrpInfoButton.Text = "Export to File"
$ExportGrpInfoButton.Height = 40
$ExportGrpInfoButton.Width = 80
$ExportGrpInfoButton.TabIndex = 6

$consultTabPage.controls.AddRange(@($RetrieveUserInfoButton,$RefreshButton,$ExportToFileButton,$UnlockAccButton,$DisableAccButton,$EnableAccButton,$SetExpDateButton,$disableExpDateButton,$changeUserPwButton,$neverExpPwButton,$doesExpPwButton,$resetButton))
$logTabPage.controls.AddRange(@($clearLogButton,$exportLogButton))
$groupTabPage.controls.AddRange(@($GetGrpButton,$ClearGrpDGVButton,$ExportGrpDGVButton,$ExportGrpInfoButton))
$adTabPage.controls.AddRange(@($RetrieveDCListButton,$ResetDCListButton;$mstscButton,$dcdiagButton,$dcdiagRepButton,$dcdiagDnsButton,$ExportDCListButton))
    #endregion

    #region Checkbox
$lockedBoolCheck = New-Object System.Windows.Forms.CheckBox
$lockedBoolCheck.Location = New-Object System.Drawing.Point(80,350)
$enabledBoolCheck = New-Object System.Windows.Forms.CheckBox
$enabledBoolCheck.Location = New-Object System.Drawing.Point(220,350)
$pwNeverExpBoolCheck = New-Object System.Windows.Forms.CheckBox
$pwNeverExpBoolCheck.Location = New-Object System.Drawing.Point(115,415)
$pwExpiredBoolCheck = New-Object System.Windows.Forms.CheckBox
$pwExpiredBoolCheck.Location = New-Object System.Drawing.Point(230,415)

$consultTabPage.controls.AddRange(@($lockedBoolCheck,$enabledBoolCheck,$pwNeverExpBoolCheck,$pwExpiredBoolCheck))
    #endregion

	#region NumUpDowns
$DayNUD = New-Object System.Windows.Forms.NumericUpDown
$DayNUD.Location = New-Object System.Drawing.Point(460,250)
$DayNUD.Width = 35
$DayNUD.Minimum = 1
$DayNUD.Maximum = 31
$DayNUD.TabIndex = 10
$DayNUD.ReadOnly = $true
$MonthNUD = New-Object System.Windows.Forms.NumericUpDown
$MonthNUD.Location = New-Object System.Drawing.Point(400,250)
$MonthNUD.Width = 35
$MonthNUD.Minimum = 1
$MonthNUD.Maximum = 12
$MonthNUD.TabIndex = 9
$MonthNUD.ReadOnly = $true
$YearNUD = New-Object System.Windows.Forms.NumericUpDown
$YearNUD.Location = New-Object System.Drawing.Point(520,250)
$YearNUD.Width = 35
$YearNUD.Minimum = 00
$YearNUD.Maximum = 99
$YearNUD.TabIndex = 11
$YearNUD.ReadOnly = $true

$consultTabPage.controls.AddRange(@($DayNUD,$MonthNUD,$YearNUD))
	#endregion	
	
	#region DataGridView
$LogDGV = New-Object System.Windows.Forms.DataGridView
$LogDGV.Location = New-Object System.Drawing.Point(20,20)
$LogDGV.ReadOnly = $true
$LogDGV.Size = '540,415'
$LogDGV.RowHeadersVisible = $false
$LogDGV.ColumnCount = 3
$LogDGV.TabIndex = 20
$LogDGV.AllowUserToOrderColumns = $false
$LogDGV.AllowUserToResizeColumns = $false
$LogDGV.ColumnHeadersHeightSizeMode = "DisableResizing"
$LogDGV.AllowUserToResizeRows = $false
$LogDGV.Columns[0].Name = "Timestamp"
$LogDGV.Columns[0].Width = 100
$LogDGV.Columns[1].Name = "User"
$LogDGV.Columns[1].Width = 100
$LogDGV.Columns[2].Name = "Status"
$LogDGV.Columns[2].Width = 320

$logTabPage.controls.Add($LogDGV)	

$DCListDGV = New-Object System.Windows.Forms.DataGridView
$DCListDGV.Location = New-Object System.Drawing.Point(20,45)
$DCListDGV.ReadOnly = $true
$DCListDGV.Size = '540,250'
$DCListDGV.RowHeadersVisible = $false
$DCListDGV.ColumnCount = 3
$DCListDGV.AllowUserToOrderColumns = $false
$DCListDGV.AllowUserToResizeColumns = $true
$DCListDGV.ColumnHeadersHeightSizeMode = "DisableResizing"
$DCListDGV.AllowUserToResizeRows = $false
$DCListDGV.Columns[0].Name = "Hostname"
$DCListDGV.Columns[0].Width = 150
$DCListDGV.Columns[1].Name = "IPV4 Address"
$DCListDGV.Columns[1].Width = 90
$DCListDGV.Columns[2].Name = "Distinguished Name"
$DCListDGV.Columns[2].Width = 280

$adTabPage.controls.Add($DCListDGV)

$GrpListDGV = New-Object System.Windows.Forms.DataGridView
$GrpListDGV.Location = New-Object System.Drawing.Point(20,45)
$GrpListDGV.ReadOnly = $true
$GrpListDGV.Size = '540,210'
$GrpListDGV.RowHeadersVisible = $false
$GrpListDGV.ColumnCount = 3
$GrpListDGV.AllowUserToOrderColumns = $false
$GrpListDGV.AllowUserToResizeColumns = $true
$GrpListDGV.ColumnHeadersHeightSizeMode = "DisableResizing"
$GrpListDGV.AllowUserToResizeRows = $false
$GrpListDGV.Columns[0].Name = "Group ID"
$GrpListDGV.Columns[0].Width = 120
$GrpListDGV.Columns[1].Name = "Group Name"
$GrpListDGV.Columns[1].Width = 150
$GrpListDGV.Columns[2].Name = "Distinguished Name"
$GrpListDGV.Columns[2].Width = 250

$GrpSelectDGV = New-Object System.Windows.Forms.DataGridView
$GrpSelectDGV.Location = New-Object System.Drawing.Point(25,345)
$GrpSelectDGV.ReadOnly = $true
$GrpSelectDGV.Size = '420,110'
$GrpSelectDGV.RowHeadersVisible = $false
$GrpSelectDGV.ColumnCount = 3
$GrpSelectDGV.AllowUserToOrderColumns = $false
$GrpSelectDGV.AllowUserToResizeColumns = $true
$GrpSelectDGV.ColumnHeadersHeightSizeMode = "DisableResizing"
$GrpSelectDGV.AllowUserToResizeRows = $false
$GrpSelectDGV.Columns[0].Name = "User ID"
$GrpSelectDGV.Columns[0].Width = 80
$GrpSelectDGV.Columns[1].Name = "User Name"
$GrpSelectDGV.Columns[1].Width = 120
$GrpSelectDGV.Columns[2].Name = "Distinguished Name"
$GrpSelectDGV.Columns[2].Width = 195

$groupTabPage.controls.AddRange(@($GrpListDGV,$GrpSelectDGV)) 

	#endregion DataGridView
	
    #region Groupbox
$ConsultInfoPanel = New-Object System.Windows.Forms.GroupBox
$ConsultInfoPanel.Location = New-Object System.Drawing.Point(20,65)
$ConsultInfoPanel.Height = 400
$ConsultInfoPanel.Width = 350
$ConsultInfoPanel.Text = "User Information"
    
$ConsultActionPanel = New-Object System.Windows.Forms.GroupBox
$ConsultActionPanel.Location = New-Object System.Drawing.Point(390,65)
$ConsultActionPanel.Height = 400
$ConsultActionPanel.Width = 175
$ConsultActionPanel.Text = "Actions"    

$DCInfoPanel = New-Object System.Windows.Forms.GroupBox
$DCInfoPanel.Location = New-Object System.Drawing.Point(20,315)
$DCInfoPanel.Height = 150
$DCInfoPanel.Width = 310
$DCInfoPanel.Text = "Domain Controller Information"

$DCActionPanel = New-Object System.Windows.Forms.GroupBox
$DCActionPanel.Location = New-Object System.Drawing.Point(350,315)
$DCActionPanel.Height = 150
$DCActionPanel.Width = 210
$DCActionPanel.Text = "Actions"

$GrpInfoPanel = New-Object System.Windows.Forms.GroupBox
$GrpInfoPanel.Location = New-Object System.Drawing.Point(20,275)
$GrpInfoPanel.Height = 190
$GrpInfoPanel.Width = 430
$GrpInfoPanel.Text = "Group Information"

$GrpActionPanel = New-Object System.Windows.Forms.Groupbox
$GrpActionPanel.Location = New-Object System.Drawing.Point(460,275)
$GrpActionPanel.Height = 190
$GrpActionPanel.Width = 100
$GrpActionPanel.Text = "Actions"

$consultTabPage.controls.AddRange(@($ConsultInfoPanel,$ConsultActionPanel))
$groupTabPage.controls.AddRange(@($GrpInfoPanel,$GrpActionPanel))
$adTabPage.controls.AddRange(@($DCInfoPanel,$DCActionPanel))
    #endregion

	#region Menu
$MainMenu = New-Object System.Windows.Forms.MenuStrip
$MainMenu.Location = New-Object System.Drawing.Point(0,0)
$MainMenu.ShowItemToolTips = $true
$mainForm.controls.Add($MainMenu)

$FileMenu = New-Object System.Windows.Forms.ToolStripMenuItem
$FileQuit = New-Object System.Windows.Forms.ToolStripMenuItem
$FileMenu.Text = "&File"
$FileQuit.Text = "&Quit"
$FileQuit.ToolTipText = "Quit the Lightweight ActiveDirectory Toolbox."
$FileMenu.DropDownItems.AddRange(@($FileQuit))

$DevMenu = New-Object System.Windows.Forms.ToolStripMenuItem
$DevBlog = New-Object System.Windows.Forms.ToolStripMenuItem
$DevWfr = New-Object System.Windows.Forms.ToolStripMenuItem
$DevWen = New-Object System.Windows.Forms.ToolStripMenuItem
$DevMenu.Text = "&Developer links"
$DevBlog.Text = "Blog (fr)"
$DevBlog.ToolTipText = "Visit the developer's blog page about this application."
$DevWfr.Text = "Website (fr)"
$DevWfr.ToolTipText = "Visit the developer's website (in French)."
$DevWen.Text = "Website (en)"
$DevWen.ToolTipText = "Visit the developer's website (in English)."
$DevMenu.DropDownItems.AddRange(@($DevBlog,$DevWfr,$DevWen))

$UpdateMenu = New-Object System.Windows.Forms.ToolStripMenuItem
$UpdateMenu.Text = "Check for updates"
$UpdateMenu.ToolTipText = "Click to check for updates. An internet connection is required."

$MainMenu.Items.AddRange(@($FileMenu,$DevMenu,$UpdateMenu))
	#endregion
	
	#region Tooltip
$NoExpPwToolTip = New-Object System.Windows.Forms.ToolTip
$DoesExpPwToolTip = New-Object System.Windows.Forms.ToolTip
$RemAccExpDateToolTip = New-Object System.Windows.Forms.ToolTip
$SetExpDateToolTip = New-Object System.Windows.Forms.ToolTip
$enableAccToolTip = New-Object System.Windows.Forms.ToolTip
$disableAccToolTip = New-Object System.Windows.Forms.ToolTip
$unlockAccToolTip = New-Object System.Windows.Forms.ToolTip
$exportToolTip = New-Object System.Windows.Forms.ToolTip
$changeUserPwToolTip = New-Object System.Windows.Forms.ToolTip
$monthToolTip = New-Object System.Windows.Forms.ToolTip
$dayToolTip = New-Object System.Windows.Forms.ToolTip
$yearToolTip = New-Object System.Windows.Forms.ToolTip
$retrieveToolTip = New-Object System.Windows.Forms.ToolTip
$refreshToolTip = New-Object System.Windows.Forms.ToolTip
$pwToolTip = New-Object System.Windows.Forms.ToolTip
$quitToolTip = New-Object System.Windows.Forms.ToolTip
$accDisplayNameVarToolTip = New-Object System.Windows.Forms.ToolTip
$LogDGVToolTip = New-Object System.Windows.Forms.ToolTip
$clearLogButtonToolTip = New-Object System.Windows.Forms.ToolTip
$exportLogButtonToolTip = New-Object System.Windows.Forms.ToolTip 
$resetButtonToolTip = New-Object System.Windows.Forms.ToolTip
$resetDCListToolTip = New-Object System.Windows.Forms.ToolTip
$retrieveDCListToolTip = New-Object System.Windows.Forms.ToolTip
$mstscButtonToolTip = New-Object System.Windows.Forms.ToolTip
$dcdiagButtonToolTip = New-Object System.Windows.Forms.ToolTip
$dcdiagRepButtonToolTip = New-Object System.Windows.Forms.ToolTip
$dcdiagDnsButtonToolTip = New-Object System.Windows.Forms.ToolTip
$ExportDCListToolTip = New-Object System.Windows.Forms.ToolTip
$GetGrpButtonToolTip = New-Object System.Windows.Forms.ToolTip
$ClearGrpDGVButtonToolTip = New-Object System.Windows.Forms.ToolTip
$grpFilterTextBoxToolTip = New-Object System.Windows.Forms.ToolTip
$ExportGrpDGVButtonToolTip = New-Object System.Windows.Forms.ToolTip
$ExportGrpInfoButtonToolTip = New-Object System.Windows.Forms.ToolTip

$NoExpPwToolTip.SetToolTip($neverExpPwButton, "Click if you want the password for this account to never expire.")
$DoesExpPwToolTip.SetToolTip($doesExpPwButton, "Click if you want the password for this account to expire as defined by the AD policy.")
$RemAccExpDateToolTip.SetToolTip($disableExpDateButton, "This will remove the account expiration date.")
$SetExpDateToolTip.SetToolTip($SetExpDateButton, "This will set the expiration date set below on the account.")
$enableAccToolTip.SetToolTip($enableAccButton, "Enable this account.")
$disableAccToolTip.SetToolTip($disableAccButton, "Disable this account.")
$unlockAccToolTip.SetToolTip($unlockAccButton, "Unlock this account.")
$exportToolTip.SetToolTip($ExportToFileButton, "Click to export the whole AD query results to a usernamed file in the script directory.")
$changeUserPwToolTip.SetToolTip($changeUserPwButton, "This will change the account password to the values typed in the two fields below.")
$monthToolTip.SetToolTip($MonthNUD, "Month.")
$dayToolTip.SetToolTip($DayNUD, "Day.")
$yearToolTip.SetToolTip($YearNUD, "Year. The last two digits will do.")
$retrieveToolTip.SetToolTip($RetrieveUserInfoButton, "Query the ActiveDirectory for the given username and start working!")
$refreshToolTip.SetToolTip($RefreshButton, "Query the ActiveDirectory for the same user to refresh any values shown.")
$pwToolTip.SetToolTip($changePwTextBox1, "Type the new password for the account if needed. The two values have to be exactly identical and have to match your AD password security policy.")
$pwToolTip.SetToolTip($changePwTextBox2, "Type the new password for the account if needed. The two values have to be exactly identical and have to match your AD password security policy.")
$accDisplayNameVarToolTip.SetToolTip($accNameTextBox, "Enter the username of the account you wish to work on.")
$LogDGVToolTip.SetToolTip($LogDGV, "History of operations made in the application.")
$clearLogButtonToolTip.SetToolTip($clearLogButton, "Clear the log. Be careful as there is no confirmation prompt.")
$exportLogButtonToolTip.SetToolTip($exportLogButton, "Export the log to a CSV file readable in Excel or LibreOffice.")
$resetButtonToolTip.SetToolTip($resetButton,"Reset all the fields to query another account.")
$resetDCListToolTip.SetToolTip($ResetDCListButton,"Wipe the chart below listing all of the domain controllers.")
$retrieveDCListToolTip.SetToolTip($RetrieveDCListButton,"Get the list of domain controllers.")
$mstscButtonToolTip.SetToolTip($mstscButton,"Open the Remote Desktop Connection application to connect to the server.")
$dcdiagButtonToolTip.SetToolTip($dcdiagButton,"Start a dcdiag instance for the selected DC.")
$dcdiagRepButtonToolTip.SetToolTip($dcdiagRepButton,"Start a dcdiag instance to test the replications on the selected DC.")
$dcdiagDnsButtonToolTip.SetToolTip($dcdiagDnsButton,"Start a dcdiag instance to test the DNS on the selected DC.")
$ExportDCListToolTip.SetToolTip($ExportDCListButton,"Export the chart below as a CSV file to be opened in Excel or LibreOffice.")
$GetGrpButtonToolTip.SetToolTip($GetGrpButton,"Retrieve the ActiveDirectory groups based on the optional filter.")
$ClearGrpDGVButtonToolTip.SetToolTip($ClearGrpDGVButton,"Clear the chart below listing the AD groups to start a new search.")
$grpFilterTextBoxToolTip.SetToolTip($grpFilterTextBox,"Filter your AD query with a group name to only retrieve what you're looking for.")
$ExportGrpDGVButtonToolTip.SetToolTip($ExportGrpDGVButton,"Export the group list in the chart below to a CSV file.")
$ExportGrpInfoButtonToolTip.SetToolTip($ExportGrpInfoButton,"Export this group's information to a text file.") 
	#endregion
	
#endregion

	#region EventHandlers

$RefreshButton.Add_Click({
	refresh
	logthis("refresh")
})

$RetrieveUserInfoButton.Add_Click({
    $UserInfo = Get-ADUser -Identity $accNameTextBox.Text -Properties *
    Retrieve($UserInfo) 
	logthis("retrieve")
	$RefreshButton.Focus()
})

$ResetButton.Add_Click({
	$accNameTextBox.Text = $null
	Resetform
	logthis("wipe")
	$accNameTextBox.Focus()
})

$ExportToFileButton.Add_Click({
	$UserInfo = Get-ADUser -Identity $accNameTextBox.Text -Properties *
	$filename = $pwd.Path+"\"+$accNameTextBox.Text+".txt"
	$UserInfo > $filename
	if ($?)
	{
		$statusLabelVar.Text = "Exported to file "+$filename+"."
		logthis("export")
	}
	else {
		$statusLabelVar.Text = "Couldn't export file."
		logthis("export")
	}})

$UnlockAccButton.Add_Click({
	Unlock-ADAccount $accNameTextBox.Text
	if ($?) {
		refresh
		$statusLabelVar.Text = "Successfully unlocked account."
		logthis("unlock")
	}
	else {
		$statusLabelVar.Text = "Failed to unlock account."
		logthis("unlock")
	}})

$EnableAccButton.Add_Click({
	Enable-ADAccount $accNameTextBox.Text
	if ($?) {
		refresh
		$statusLabelVar.Text = "Successfully enabled account."
		logthis("enable")
	}
	else {
		$statusLabelVar.Text = "Failed to enable account."
		logthis("enable")
	}
	})

$DisableAccButton.Add_Click({
	Disable-ADAccount $accNameTextBox.Text
	if ($?) {
		refresh
		$statusLabelVar.Text = "Successfully disabled account."
		logthis("disable")
	}
	else {
		$statusLabelVar.Text = "Failed to disable account."
		logthis("disable")
	}})

$FileQuit.Add_Click({
	$mainForm.Close()
	})

$changeUserPwButton.Add_Click({
	if($changePwTextBox1.Text -ne $changePwTextBox2.Text)
		{
		$statusLabelVar.Text = "Couldn't change password. Be sure to type the exact same passwords."
		logthis("chgupw")
		}
	else
		{
		Set-ADAccountPassword -Identity $accNameTextBox.Text -Reset -NewPassword (ConvertTo-SecureString -AsPlainText $changePwTextBox1.Text -Force)
		if ($?) {
		refresh
		$statusLabelVar.Text = "Changed user password."
		logthis("chgupw")
		}
	else {
		$statusLabelVar.Text = "Failed to change password. Be sure to have the right to do so and that it matches the password complexity."
		logthis("chgupw")
	}}})

$disableExpDateButton.Add_Click({
	Clear-ADAccountExpiration -Identity $accNameTextBox.Text
	if ($?) {
	refresh
	$statusLabelVar.Text = "Successfully cleared this account's expiration date."
	logthis("remexp")
	}
	else {
	$statusLabelVar.Text = "Failed to clear this account's expiration date."
	logthis("remexp")
	}
	})

$SetExpDateButton.Add_Click({
	$expDateValue = $MonthNUD.Value.ToString()+"/"+$DayNUD.Value.ToString()+"/20"+$YearNUD.Value.ToString()
	$expDateValue = [datetime]"$expDateValue"
	Set-ADAccountExpiration -Identity $accNameTextBox.Text -DateTime $expDateValue
	if ($?) {
	refresh
	$statusLabelVar.Text = "Successfully set this account's expiration date."
	logthis("setexp")
	}
	else{
	$statusLabelVar.Text = "Failed to set this account's expiration date."
	logthis("setexp")
	}
	})

$neverExpPwButton.Add_Click({
	Set-AdUser -Identity $accNameTextBox.Text -PasswordNeverExpires:$true
	if ($?) {
	refresh
	$statusLabelVar.Text = "The password for this account is set to never expire."
	logthis("pwexp0")
	}
	else {
	$statusLabelVar.Text = "Failed to switch on the 'never expire' flag."
	logthis("pwexp0")
	}
	})

$doesExpPwButton.Add_Click({
	Set-AdUser -Identity $accNameTextBox.Text -PasswordNeverExpires:$false
	if ($?) {
	refresh
	$statusLabelVar.Text = "The password for this account is set to expire according to the AD policy."
	logthis("pwexp1")
	}
	else {
	$statusLabelVar.Text = "Failed to switch off the 'never expire' flag."
	logthis("pwexp1")
	}
	})

$DevBlog.Add_Click({
	[system.Diagnostics.Process]::start("https://blog.schmitouille.net/p/lightweight-ad-toolbox.html")
	})

$DevWfr.Add_Click({
	[system.Diagnostics.Process]::start("http://www.schmitouille.pro")
	})

$DevWen.Add_Click({
	[system.Diagnostics.Process]::start("http://www.schmitouille.pro/index-en.html")
	})

$clearLogButton.Add_Click({
	$LogDGV.Rows.Clear()
	$statusLabelVar.Text = "Log successfully cleared."
	})

$exportLogButton.Add_Click({
	$CsvNameDump = Get-Date -Format "yyyyMMddHHmmss"
	$CsvFileDump = "log-export-$CsvNameDump.csv"
	$HeaderDump = "Timestamp,User,Status"
	Add-Content -Value $HeaderDump -Path $CsvFileDump
	if ($?){logtocsv}
	else
		{
		$statusLabelVar.Text = "Couldn't export the log to CSV."
		}
	})

$RetrieveDCListButton.Add_Click({
	$DCListArray = (Get-ADForest).Domains | %{ Get-ADDomainController -Filter * -Server $_ }
	if ($?) {
		foreach ($DC in $DCListArray)
		{
				$DCListDGV.Rows.Add($DC.Hostname,$DC.IPv4Address,$DC.ComputerObjectDN)
		}
		$statusLabelVar.Text = "Successfully retrieved domain controllers from the forest."
		logthis("retrievedc")
		$RetrieveDCListButton.Enabled = $false
		$ResetDCListButton.Enabled = $true
		$ExportDCListButton.Enabled = $true
		foreach ($DCRow in $DCListDGV.Rows)
		{
			if ($DCRow.Cells[0].Value -ne $null) {
			$DCListComboBox.Items.Add($DCRow.Cells[0].Value) }
		}
		$DCListComboBox.Enabled = $true
	}
	else {
		$statusLabelVar.Text = "Couldn't fetch the domain controllers from the forest."
		logthis("retrievedc")
	}
	})

$ResetDCListButton.Add_Click({
	$DCListDGV.Rows.Clear()
	$DCListComboBox.Items.Clear()
	$statusLabelVar.Text = "Domain controller list wiped."
	$RetrieveDCListButton.Enabled = $true
	$ResetDCListButton.Enabled = $false
	$DCListComboBox.Enabled = $false
	$mstscButton.Enabled = $false
	$dcdiagButton.Enabled = $false
	$dcdiagDnsButton.Enabled = $false
	$dcdiagRepButton.Enabled = $false
	$ExportDCListButton.Enabled = $false
	$DCIPV4LabelVar.Text = $null
	$DCOSverLabelVar.Text = $null
	$DCSiteLabelVar.Text = $null
	})

$DCListComboBox.Add_SelectedIndexChanged({
	$DCinfo = Get-ADDomainController $DCListComboBox.Text
	$DCIPV4LabelVar.Text = $DCinfo.IPv4Address
	$DCOSverLabelVar.Text = $DCinfo.OperatingSystem
	$DCSiteLabelVar.Text = $DCinfo.Site
	$mstscButton.Enabled = $true
	$dcdiagButton.Enabled = $true
	$dcdiagDnsButton.Enabled = $true
	$dcdiagRepButton.Enabled = $true
	})

$mstscButton.Add_Click({
	$rdpServ = $DCListComboBox.Text
	Start-Process "$env:windir\system32\mstsc.exe" -ArgumentList "/v:$rdpServ"
	})

$dcdiagButton.Add_Click({
	$rdpServ = $DCListComboBox.Text
	$statusLabelVar.Text = "Started a dcdiag test on $rdpserv."
	logthis("dcdiag")
	Start-Process "$env:windir\system32\cmd.exe" -ArgumentList "/k dcdiag.exe -s:$rdpServ"
	})

$dcdiagRepButton.Add_Click({
	$rdpServ = $DCListComboBox.Text
	$statusLabelVar.Text = "Started a dcdiag replication test on $rdpserv."
	logthis("dcdiag")
	Start-Process "$env:windir\system32\cmd.exe" -ArgumentList "/k dcdiag.exe /test:replications -s:$rdpServ"
	})

$dcdiagDnsButton.Add_Click({
	$rdpServ = $DCListComboBox.Text
	$statusLabelVar.Text = "Started a dcdiag DNS test on $rdpserv."
	logthis("dcdiag")
	Start-Process "$env:windir\system32\cmd.exe" -ArgumentList "/k dcdiag.exe /test:dns -s:$rdpServ"
	})

$ExportDCListButton.Add_Click({
	$CsvNameDump = Get-Date -Format "yyyyMMddHHmmss"
	$CsvFileDump = "dclist-export-$CsvNameDump.csv"
	$HeaderDump = "Hostname,IPV4,Distinguished Name"
	Add-Content -Value $HeaderDump -Path $CsvFileDump
	if ($?){dctocsv}
	else
		{
		$statusLabelVar.Text = "Couldn't export the domain controller list to CSV."
		logthis("exportdc")
		}
	})

$GetGrpButton.Add_Click({
	if ($grpFilterTextBox.Text -eq "") { $adQuery = "Get-ADgroup -filter * -properties samAccountName,Name,DistinguishedName" }
	else { 
		$filter = $grpFilterTextBox.Text
		$adQuery = "Get-ADgroup -filter 'Name -like ""$filter""' -properties samAccountName,Name,DistinguishedName" 
		$statusLabelVar.Text = $adQuery
		}
	$GroupListArray = Invoke-Expression $adQuery
		if ($?) {
			foreach ($Grp in $GroupListArray)
			{
				$GrpListDGV.Rows.Add($Grp.samAccountName,$Grp.Name,$Grp.DistinguishedName)
			}
			$statusLabelVar.Text = "Successfully retrieved AD groups."
			$ClearGrpDGVButton.Enabled = $true
			$GetGrpButton.Enabled = $false
			logthis("retrievegrp")
			$grpFilterTextBox.Enabled = $false
			$GrpListComboBox.Enabled = $true
			foreach ($GrpRow in $GrpListDGV.Rows)
			{
				if ($GrpRow.Cells[1].Value -ne $null) {
				$GrpListComboBox.Items.Add($GrpRow.Cells[1].Value) }
			}
			}
		else {
			$statusLabelVar.Text = "Couldn't list the AD groups."
			logthis("retrievegrp")
			}
	})

$ClearGrpDGVButton.Add_Click({
	$GetGrpButton.Enabled = $true
	$ClearGrpDGVButton.Enabled = $false
	$GrpListComboBox.Enabled = $false
	$ExportGrpInfoButton.Enabled = $false
	$grpFilterTextBox.Enabled = $true
	$GrpListDGV.Rows.Clear()
	$GrpListComboBox.Items.Clear()
	$GrpSelectDGV.Rows.Clear()
	$grpFilterTextBox.Text = $null
	$statusLabelVar.Text = "Group list wiped."
})

$ExportGrpDGVButton.Add_Click({
	$CsvNameDump = Get-Date -Format "yyyyMMddHHmmss"
	$CsvFileDump = "grouplist-export-$CsvNameDump.csv"
	$HeaderDump = "Group ID,Group Name,Distinguished Name"
	Add-Content -Value $HeaderDump -Path $CsvFileDump
	if ($?){grptocsv}
	else
		{
		$statusLabelVar.Text = "Couldn't export the group list to CSV."
		logthis("exportdc")
		}
})

$GrpListComboBox.Add_SelectedIndexChanged({
	$GrpSelectDGV.Rows.Clear()
	$ExportGrpInfoButton.Enabled = $true
	$GrpInfo = Get-ADgroup $GrpListComboBox.Text -Properties *
	foreach ($GrpMember in $GrpInfo.Member)
	{
		$UserOrGrp = Get-ADObject $GrpMember | select ObjectClass
		if ($UserOrGrp.ObjectClass -eq 'user'){
			$MemberInfo = Get-ADUser $GrpMember
			$MemberName = $MemberInfo.GivenName+" "+$MemberInfo.Surname
			$GrpSelectDGV.Rows.Add($MemberInfo.samAccountName,$MemberName,$MemberInfo.DistinguishedName)
		}
	}		
})

$ExportGrpInfoButton.Add_Click({
	$GrpInfo = Get-ADgroup $GrpListComboBox.Text -Properties *
	$filename = $pwd.Path+"\"+$GrpListComboBox.Text+".txt"
	$GrpInfo > $filename
	if ($?)
	{
		$statusLabelVar.Text = "Exported group information to file "+$filename+"."
		logthis("exportgrpinfo")
	}
	else {
		$statusLabelVar.Text = "Couldn't export file."
		logthis("exportgrpinfo")
	}
})

$UpdateMenu.Add_Click({
$AvailVerQuery = Invoke-WebRequest "http://files.schmitouille.pro/lwadt/curver" | Select-Object -ExpandProperty RawContent
$relindex = $AvailVerQuery.IndexOf("current:")
$AvailVer = $AvailVerQuery.Substring($relindex+8,2)
	if ($AvailVer -eq $curver)
	{
		$UpdateMenu.Text = "Up to date."
		$UpdateMenu.ToolTipText = "Your release is the most up to date."
		$UpdateMenu.Enabled = $false
	}
	else
	{
		$UpdateMenu.Text = "New version available: $AvailVer"
		$UpdateMenu.ToolTipText = "A more recent version is available to download. You can find the link to the download in the Developer Links menu."
	}
})

#endregion

	#region Functions 
function resetform{
	$UserInfo = $null
	$UserGroups = $null

	$accNameLabelVar.Text = $null
	$accDisplayNameVar.Text = $null
	$lastlogonDateVar.Text = $null
	$distinguishedNameVar.Text = $null
	$lastwrongpwVar.Text = $null
	$whencreatedVar.Text = $null
	$lastSetpwVar.Text = $null
	$changePwTextBox1.Text = $null
	$changePwTextBox2.Text = $null
	$GroupComboBox.Items.Clear()
	$lockedBoolCheck.Checked = $false
	$enabledBoolCheck.Checked = $false
	$pwNeverExpBoolCheck.Checked = $false
	$pwExpiredBoolCheck.Checked = $false
	$accNameTextBox.Enabled = $true
	$GroupComboBox.Enabled = $false
	$ExportToFileButton.Enabled = $false
	$RetrieveUserInfoButton.Enabled = $true
	$UnlockAccButton.Enabled = $false
	$DisableAccButton.Enabled = $false
	$EnableAccButton.Enabled = $false
	$RefreshButton.Enabled = $false
	$SetExpDateButton.Enabled = $false
	$DayNUD.Enabled = $false
	$MonthNUD.Enabled = $false
	$YearNUD.Enabled = $false
	$disableExpDateButton.Enabled = $false
	$neverExpPwButton.Enabled = $false
	$doesExpPwButton.Enabled = $false
	$changeUserPwButton.Enabled = $false
	$changePwTextBox1.Enabled = $false
	$changePwTextBox2.Enabled = $false

	$accExpDateVar.Text = "Not Set"
	$statusLabelVar.Text = "Ready."
}

function retrieve{
	param($user)
	if ($user -ne $null)
			{
			$accNameLabelVar.Text = $user.samAccountName
			$accDisplayNameVar.Text = $user.DisplayName
			$accNameTextBox.Enabled = $false
			$lastlogonDateVar.Text = $user.lastLogonDate
			$distinguishedNameVar.Text = $user.DistinguishedName
			$lastwrongpwVar.Text = $user.lastBadPasswordAttempt
			$whenCreatedVar.Text = $user.CreateTimeStamp
			$lastSetpwVar.Text = $user.PasswordLastSet
			$statusLabelVar.Text = "User found!"
		
			$GroupComboBox.Enabled = $true
			$SetExpDateButton.Enabled = $true
			$ExportToFileButton.Enabled = $true
			$retrieveUserInfoButton.Enabled = $false
			$refreshButton.Enabled = $true
			$DayNUD.Enabled = $true
			$MonthNUD.Enabled = $true
			$YearNUD.Enabled = $true
			
			$changeUserPwButton.Enabled = $true
			$changePwTextBox1.Enabled = $true
			$changePwTextBox2.Enabled = $true
	   
			$UserGroups = $user | select MemberOf
			$UserGroups = $UserGroups.MemberOf
			foreach($grp in $UserGroups)
			{
				$GrpNameCutIndex = $grp.ToString().IndexOf(",OU=")
				if ($GrpNameCutIndex -eq -1) { $GrpNameCutIndex = $grp.ToString().IndexOf(",CN=") }
				$ProperGrpName = $grp.ToString().Substring(3,$GrpNameCutIndex-3)
				$GroupComboBox.Items.Add($ProperGrpName)
				}

			if($user.LockedOut -eq "True")
			{
			$lockedBoolCheck.Checked = $true
			$UnlockAccButton.Enabled = $true
			}
			if($user.Enabled -eq "True")
			{
				$enabledBoolCheck.Checked = $true
				$enableAccButton.Enabled = $false
				$disableAccButton.Enabled = $true
				}
			else {
				$enabledBoolCheck.Checked = $false
				$enableAccButton.Enabled = $true
				$disableAccButton.Enabled = $false
				}
			if($user.PasswordNeverExpires -eq "True")
			{
				$pwNeverExpBoolCheck.Checked = $true
				$doesExpPwButton.Enabled = $true
			}
			else {
				$neverExpPwButton.Enabled = $true
			}
			if($user.PasswordExpired -eq "True")
			{
				$pwExpiredBoolCheck.Checked = $true
				$neverExpPwButton.Enabled = $true
			}
			if($user.AccountExpirationDate -ne $null)
			{
				$accExpDateVar.Text = $user.AccountExpirationDate
				$disableExpDateButton.Enabled = $true
			}
			}
		else {$statusLabelVar.Text = "User not found!"}    
	}

function refresh{
	resetform
		$UserInfo = Get-ADUser -Identity $accNameTextBox.Text -Properties *
		Retrieve($UserInfo)
		$RefreshButton.Focus()
}

function logthis{
	param ($actiontype)
	$actualDate = Get-Date -format "MM/dd/yy HH:mm:ss"
	$startUser = $env:username
	if ($actiontype -eq "exportgrpinfo")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$startUser,$statusLabelVar.Text)
		}
	if ($actiontype -eq "exportgrp")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$startUser,$statusLabelVar.Text)
		}
	if ($actiontype -eq "retrievegrp")
		{
		if ($grpFilterTextBox.Text -eq "") { $LogDGV.Rows.Insert(0,$actualDate,$startUser,$statusLabelVar.Text) }
		else { $LogDGV.Rows.Insert(0,$actualDate,$startUser,"Successfully retrieved AD groups with $filter name filter.") }
		}
	if ($actiontype -eq "exportdc")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$startUser,$statusLabelVar.Text)
		}
	if ($actiontype -eq "dcdiag")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$startUser,$statusLabelVar.Text)
		}
	if ($actiontype -eq "wipe")
		{
		$LogDGV.Rows.Insert(0,$actualDate,"-- None --","Reset.")
		}
	if ($actiontype -eq "retrieve")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$accNameTextBox.Text,"Retrieved user information - "+$statusLabelVar.Text)
		}
	if ($actiontype -eq "refresh")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$accNameTextBox.Text,"Refreshed displayed information.")
		}
	if ($actiontype -eq "export")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$accNameTextBox.Text,$statusLabelVar.Text)
		}
	if ($actiontype -eq "unlock")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$accNameTextBox.Text,$statusLabelVar.Text)
		}
	if ($actiontype -eq "disable")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$accNameTextBox.Text,$statusLabelVar.Text)
		}
	if ($actiontype -eq "enable")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$accNameTextBox.Text,$statusLabelVar.Text)
		}
	if ($actiontype -eq "setexp")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$accNameTextBox.Text,$statusLabelVar.Text)
		}	
	if ($actiontype -eq "remexp")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$accNameTextBox.Text,$statusLabelVar.Text)
		}
	if ($actiontype -eq "pwexp0")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$accNameTextBox.Text,$statusLabelVar.Text)
		}
	if ($actiontype -eq "pwexp1")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$accNameTextBox.Text,$statusLabelVar.Text)
		}
	if ($actiontype -eq "chgupw")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$accNameTextBox.Text,$statusLabelVar.Text)
		}
	if ($actiontype -eq "retrievedc")
		{
		$LogDGV.Rows.Insert(0,$actualDate,$startUser,$statusLabelVar.Text)
		}
}

function logtocsv{
	foreach ($rowDump in $LogDGV.Rows)
			{
			$finalDump = $rowDump.Cells[0].Value+","+$rowDump.Cells[1].Value+","+$rowDump.Cells[2].Value
			Add-Content -Value $finalDump -Path $CsvFileDump
			}
			$statusLabelVar.Text = "Log successfully exported."
}

function dctocsv{
	foreach ($rowDump in $DCListDGV.Rows)
			{
			$finalDump = $rowDump.Cells[0].Value+","+$rowDump.Cells[1].Value+","+$rowDump.Cells[2].Value
			Add-Content -Value $finalDump -Path $CsvFileDump
			}
			$statusLabelVar.Text = "Domain controller list successfully exported."
			logthis("exportdc")
}

function grptocsv{
	foreach ($rowDump in $GrpListDGV.Rows)
			{
			$finalDump = $rowDump.Cells[0].Value+","+$rowDump.Cells[1].Value+","+$rowDump.Cells[2].Value
			Add-Content -Value $finalDump -Path $CsvFileDump
			}
			$statusLabelVar.Text = "Group list successfully exported."
			logthis("exportgrp")
}

function initeverything{
	#consult
	$GroupComboBox.Enabled = $false
	$ExportToFileButton.Enabled = $false
	$lockedBoolCheck.Enabled = $false
	$lockedBoolCheck.Checked = $false
	$enabledBoolCheck.Enabled = $false
	$enabledBoolCheck.Checked = $false
	$pwNeverExpBoolCheck.Checked = $false
	$pwNeverExpBoolCheck.Enabled = $false
	$pwExpiredBoolCheck.Checked = $false
	$pwExpiredBoolCheck.Enabled = $false
	$UnlockAccButton.Enabled = $false
	$DisableAccButton.Enabled = $false
	$EnableAccButton.Enabled = $false
	$RefreshButton.Enabled = $false
	$SetExpDateButton.Enabled = $false
	$DayNUD.Enabled = $false
	$MonthNUD.Enabled = $false
	$YearNUD.Enabled = $false
	$disableExpDateButton.Enabled = $false
	$neverExpPwButton.Enabled = $false
	$doesExpPwButton.Enabled = $false
	$changeUserPwButton.Enabled = $false
	$changePwTextBox1.Enabled = $false
	$changePwTextBox2.Enabled = $false
	$currentdate = Get-Date -UFormat "%d%m%y"
	$DayNUD.Value = $currentdate.Substring(0,2)
	$MonthNUD.Value = $currentdate.Substring(2,2)
	$YearNUD.Value = $currentdate.Substring(4,2)
	
	#ad
	$ExportDCListButton.Enabled = $false
	$RetrieveDCListButton.Enabled = $true
	$ResetDCListButton.Enabled = $false
	$DCListComboBox.Enabled = $false
	$mstscButton.Enabled = $false
	$dcdiagButton.Enabled = $false
	$dcdiagDnsButton.Enabled = $false
	$dcdiagRepButton.Enabled = $false
	
	#group
	$ClearGrpDGVButton.Enabled = $false
	$GrpListComboBox.Enabled = $false
	$ExportGrpInfoButton.Enabled = $false
}
#endregion

	#region Actual Script Code

initeverything
$mainForm.ShowDialog()

	#endregion